# glimpse.js [![Build Status](https://travis-ci.org/racker/glimpse.js.png?branch=master)](https://travis-ci.org/racker/glimpse.js)

A JavaScript library for making beautiful graphs and visualizations effortlessly.

Its purpose is to empower developers to quickly render data as standards-compliant web-based visualizations.
Glimpse.js requires very little code and has virtually no learning curve, yet is customizable enough to allow for the most complex data visualizations.
We leverage countless hours of work that have already gone into the open-source community by building on top of the immensely popular
[d3.js](http://d3js.org/) library (a lower-level data visualization library).
We take that work one step further by providing a simpler API and by drastically reducing the amount of code necessary for the end-user to write.
Interactive time-series graphs can be created in as little as 2-3 lines of code.

[Read the docs to get started.](https://github.com/racker/glimpse.js/wiki)


## Features
- Includes a bundled version of d3.js.
- d3 plugin support.
- Pure SVG graphs (no CSS or HTML).
- Line graphs.
- Area graphs.


## Browser Support
- IE9, IE10
- Safari (latest)
- Chrome (latest)
- Firefox (latest)

## Dependencies
- d3.js (comes bundled)


## Contribute
See the [contributing docs](https://github.com/racker/glimpse.js/blob/master/CONTRIBUTING.md)


## Versioning
glimpse.js uses [semantic versioning](http://semver.org/).


## License

Copyright 2013 Rackspace

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

   http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
